/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

	icl "Odium.h"

	org $f0

fcnt	.ds 2
fadr	.ds 2
fhlp	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1

WIDTH	= 40
HEIGHT	= 30

; ---	BASIC switch OFF
	org $2000\ mva #$ff portb\ rts\ ini $2000

; ---	MAIN PROGRAM
	org $2000
ant	dta $44,a(scr)
	dta $84,$84,$04,$04,$04,$84,$84,$04,$04,$84,$84,$84,$84,$84,$04,$04
	dta $04,$04,$04,$04,$04,$84,$84,$84,$04,$84,$04,$04,$04
	dta $41,a(ant)

scr	ins "Odium.scr"

	.ds 0*40

	.ALIGN $0400
fnt	ins "Odium.fnt"

	ift USESPRITES
	.ALIGN $0800
pmg	.ds $0300
	ift FADECHR = 0
	SPRITES
	els
	.ds $500
	eif
	eif

main
	jsr	InitRMT				;//------------------------------------- ADD THIS LINE FOR RMT REPLAY
; ---	init PMG

	ift USESPRITES
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	eif

	lda:cmp:req $14		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #$00 nmien		;stop NMI interrupts
	sta dmactl
	mva #$fe portb		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	mva #$c0 nmien		;switch on NMI+DLI again

	ift CHANGES		;if label CHANGES defined

_lp	lda trig0		; FIRE #0
	beq stop

	lda trig1		; FIRE #1
	beq stop

	lda consol		; START
	and #1
	beq stop

	lda skctl
	and #$04
	bne _lp			;wait to press any key; here you can put any own routine

	els

null	jmp DLI.dli1		;CPU is busy here, so no more routines allowed

	eif


stop
	jsr RASTERMUSICTRACKER+9	;all sounds off		;//------------------------------------- ADD THIS LINE FOR RMT REPLAY
	
	mva #$00 pmcntl		;PMG disabled
	tax
	sta:rne hposp0,x+

	mva #$ff portb		;ROM switch on
	mva #$40 nmien		;only NMI interrupts, DLI disabled
	cli			;IRQ enabled

	rts			;return to ... DOS

; ---	DLI PROGRAM

.local	DLI

	?old_dli = *

	ift !CHANGES

dli1	lda trig0		; FIRE #0
	beq stop

	lda trig1		; FIRE #1
	beq stop

	lda consol		; START
	and #1
	beq stop

	lda skctl
	and #$04
	beq stop

	lda vcount
	cmp #$02
	bne dli1

	:3 sta wsync

	DLINEW dli7

	eif

dli_start

dli7
	sta regA

	sta wsync		;line=16
	sta wsync		;line=17
	sta wsync		;line=18
	sta wsync		;line=19
c8	lda #$C6
	sta wsync		;line=20
	sta color2
c9	lda #$C4
	sta wsync		;line=21
	sta color2
	DLINEW dli8 1 0 0

dli8
	sta regA

	sta wsync		;line=24
c10	lda #$C6
	sta wsync		;line=25
	sta color2
c11	lda #$C4
	sta wsync		;line=26
	sta color2
	sta wsync		;line=27
c12	lda #$C6
	sta wsync		;line=28
	sta color2
c13	lda #$C4
	sta wsync		;line=29
	sta color2
c14	lda #$C6
	sta wsync		;line=30
	sta color2
	DLINEW dli9 1 0 0

dli9
	sta regA

	sta wsync		;line=56
	sta wsync		;line=57
	sta wsync		;line=58
	sta wsync		;line=59
c15	lda #$C8
	sta wsync		;line=60
	sta color2
c16	lda #$C6
	sta wsync		;line=61
	sta color2
	DLINEW dli10 1 0 0

dli10
	sta regA
	stx regX
	sty regY

	sta wsync		;line=64
c17	lda #$C8
	sta wsync		;line=65
	sta color2
c18	lda #$C6
	sta wsync		;line=66
	sta color2
	sta wsync		;line=67
c19	lda #$C8
	sta wsync		;line=68
	sta color2
c20	lda #$C6
	sta wsync		;line=69
	sta color2
c21	lda #$C8
	sta wsync		;line=70
	sta color2
	sta wsync		;line=71
	sta wsync		;line=72
	sta wsync		;line=73
	sta wsync		;line=74
	sta wsync		;line=75
	sta wsync		;line=76
	sta wsync		;line=77
	sta wsync		;line=78
c22	lda #$C8
c23	ldx #$FC
c24	ldy #$8C
	sta wsync		;line=79
	sta color1
	stx color2
	sty color3
	sta wsync		;line=80
	sta wsync		;line=81
	sta wsync		;line=82
s4	lda #$00
x8	ldx #$69
c25	ldy #$28
	sta wsync		;line=83
	sta sizep3
	stx hposp3
	sty colpm3
	lda #$01
	sta wsync		;line=84
	sta gtictl
	DLINEW DLI.dli2 1 1 1

dli2
	sta regA
	lda >fnt+$400*$01
	sta wsync		;line=88
	sta chbase
	DLINEW dli11 1 0 0

dli11
	sta regA
	stx regX
	sty regY

	sta wsync		;line=96
	sta wsync		;line=97
	sta wsync		;line=98
c26	lda #$CA
	ldx #$04
s5	ldy #$00
	sta wsync		;line=99
	sta color1
	stx gtictl
	sty sizep2
x9	lda #$5B
	sta hposp2
c27	lda #$C8
	sta wsync		;line=100
	sta color1
	DLINEW dli12 1 1 1

dli12
	sta regA
	stx regX
	sty regY

c28	lda #$CA
s6	ldx #$03
x10	ldy #$8D
	sta wsync		;line=104
	sta color1
	stx sizep1
	sty hposp1
c29	lda #$2A
	sta colpm1
c30	lda #$C8
	sta wsync		;line=105
	sta color1
c31	lda #$00
	sta wsync		;line=106
	sta color3
c32	lda #$CA
	sta wsync		;line=107
	sta color1
c33	lda #$C8
	sta wsync		;line=108
	sta color1
c34	lda #$CA
	sta wsync		;line=109
	sta color1
	DLINEW dli13 1 1 1

dli13
	sta regA
	stx regX
	sty regY

s7	lda #$01
x11	ldx #$53
c35	ldy #$2A
	sta wsync		;line=112
	sta sizep3
	stx hposp3
	sty colpm3
	DLINEW dli14 1 1 1

dli14
	sta regA
	stx regX
	sty regY

	sta wsync		;line=120
	sta wsync		;line=121
	sta wsync		;line=122
	sta wsync		;line=123
	sta wsync		;line=124
	sta wsync		;line=125
c36	lda #$FC
c37	ldx #$CA
c38	ldy #$0C
	sta wsync		;line=126
	sta color1
	stx color2
	sty color3
	sta wsync		;line=127
	sta wsync		;line=128
	sta wsync		;line=129
	sta wsync		;line=130
	sta wsync		;line=131
x12	lda #$63
c39	ldx #$2A
	sta wsync		;line=132
	sta hposp2
	stx colpm2
c40	lda #$CC
	sta wsync		;line=133
	sta color2
c41	lda #$CA
	sta wsync		;line=134
	sta color2
	sta wsync		;line=135
	sta wsync		;line=136
	sta wsync		;line=137
c42	lda #$CC
	sta wsync		;line=138
	sta color2
c43	lda #$CA
	sta wsync		;line=139
	sta color2
	sta wsync		;line=140
c44	lda #$CC
	sta wsync		;line=141
	sta color2
c45	lda #$CA
	sta wsync		;line=142
	sta color2
c46	lda #$CC
s8	ldx #$03
x13	ldy #$55
	sta wsync		;line=143
	sta color2
	stx sizep0
	sty hposp0
c47	lda #$18
	sta colpm0
s9	lda #$03
	sta wsync		;line=144
	sta sizem
	sta wsync		;line=145
	sta wsync		;line=146
	sta wsync		;line=147
	sta wsync		;line=148
	sta wsync		;line=149
	sta wsync		;line=150
s10	lda #$C3
x14	ldx #$6A
	sta wsync		;line=151
	sta sizem
	stx hposm3
	lda >fnt+$400*$02
	sta wsync		;line=152
	sta chbase
	sta wsync		;line=153
	sta wsync		;line=154
c48	lda #$CC
c49	ldx #$FC
c50	ldy #$1A
	sta wsync		;line=155
	sta color1
	stx color2
	sty color3
	sta wsync		;line=156
	sta wsync		;line=157
c51	lda #$CE
	sta wsync		;line=158
	sta color1
c52	lda #$CC
	sta wsync		;line=159
	sta color1
x15	lda #$97
c53	ldx #$18
	sta wsync		;line=160
	sta hposp3
	stx colpm3
	sta wsync		;line=161
	sta wsync		;line=162
c54	lda #$CE
	sta wsync		;line=163
	sta color1
c55	lda #$CC
	sta wsync		;line=164
	sta color1
	sta wsync		;line=165
c56	lda #$CE
s11	ldx #$03
x16	ldy #$84
	sta wsync		;line=166
	sta color1
	stx sizep2
	sty hposp2
c57	lda #$16
	sta colpm2
c58	lda #$CC
c59	ldx #$1C
	sta wsync		;line=167
	sta color1
	stx color2
c60	lda #$CE
c61	ldx #$0C
	sta wsync		;line=168
	sta color1
	stx color3
s12	lda #$03
x17	ldx #$61
c62	ldy #$16
	sta wsync		;line=169
	sta sizep3
	stx hposp3
	sty colpm3
	sta wsync		;line=170
	sta wsync		;line=171
	sta wsync		;line=172
	sta wsync		;line=173
	sta wsync		;line=174
c63	lda #$00
	sta wsync		;line=175
	sta color1
	lda >fnt+$400*$00
	sta wsync		;line=176
	sta chbase
	DLINEW dli3 1 1 1

dli3
	sta regA
	lda >fnt+$400*$02
	sta wsync		;line=184
	sta chbase
	sta wsync		;line=185
	sta wsync		;line=186
c64	lda #$02
	sta wsync		;line=187
	sta color1
c65	lda #$00
	sta wsync		;line=188
	sta color1
	DLINEW dli15 1 0 0

dli15
	sta regA

c66	lda #$02
	sta wsync		;line=192
	sta color1
c67	lda #$00
	sta wsync		;line=193
	sta color1
	sta wsync		;line=194
c68	lda #$02
	sta wsync		;line=195
	sta color1
c69	lda #$00
	sta wsync		;line=196
	sta color1
c70	lda #$02
	sta wsync		;line=197
	sta color1
	DLINEW dli4 1 0 0

dli4
	sta regA
	lda >fnt+$400*$00
	sta wsync		;line=200
	sta chbase
	DLINEW dli16 1 0 0

dli16
	sta regA

c71	lda #$04
	sta wsync		;line=216
	sta color1
c72	lda #$02
	sta wsync		;line=217
	sta color1
	sta wsync		;line=218
	sta wsync		;line=219
	sta wsync		;line=220
c73	lda #$04
	sta wsync		;line=221
	sta color1
c74	lda #$02
	sta wsync		;line=222
	sta color1
	sta wsync		;line=223
c75	lda #$04
	sta wsync		;line=224
	sta color1
c76	lda #$02
	sta wsync		;line=225
	sta color1
c77	lda #$04
	sta wsync		;line=226
	sta color1

	lda regA
	rti

.endl

; ---

CHANGES = 1
FADECHR	= 0

SCHR	= 127

; ---

.proc	NMI

	bit nmist
	bpl VBL

	jmp DLI.dli_start
dliv	equ *-2

VBL
	sta regA
	stx regX
	sty regY

	sta nmist		;reset NMI flag

	mwa #ant dlptr		;ANTIC address program

	mva #@dmactl(standard|dma|lineX1|players|missiles) dmactl	;set new screen width

	inc cloc		;little timer

; Initial values

	lda >fnt+$400*$00
	sta chbase
c0	lda #$26
	sta colbak
c1	lda #$22
	sta color0
c2	lda #$FC
	sta color1
c3	lda #$C4
	sta color2
c4	lda #$0C
	sta color3
	lda #$02
	sta chrctl
	lda #$04
	sta gtictl
s0	lda #$03
	sta sizep2
	sta sizep3
s1	lda #$F0
	sta sizem
x0	lda #$56
	sta hposp2
x1	lda #$76
	sta hposp3
x2	lda #$9E
	sta hposm2
x3	lda #$96
	sta hposm3
c5	lda #$18
	sta colpm2
	sta colpm3
s2	lda #$00
	sta sizep1
x4	lda #$5F
	sta hposp1
c6	lda #$18
	sta colpm1
s3	lda #$01
	sta sizep0
x5	lda #$77
	sta hposp0
c7	lda #$0E
	sta colpm0
x6	lda #$A2
	sta hposm0
x7	lda #$00
	sta hposm1

	mwa #DLI.dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines
	jsr RASTERMUSICTRACKER+3					;//------------------------------------- ADD THIS LINE FOR RMT REPLAY
	
quit
	lda regA
	ldx regX
	ldy regY
	rti

.endp

; ---
	run main
; ---

	opt l-

.MACRO	SPRITES
missiles
	.he 00 00 00 00 00 00 00 00 00 00 00 F0 F0 F0 F0 F0
	.he F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0
	.he F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0
	.he F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0
	.he F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0
	.he F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 F0 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 03 03 03 03 03 03 03 C3
	.he C3 C3 C3 C3 C3 C3 C3 C3 03 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player0
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 C7 C7 E7 E7 E7 E7 E7 E7 E7
	.he E7 F5 F1 F1 F1 F9 F9 F9 FD FF FF FF FF FF FF FF
	.he FF 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player1
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 FF FF FF FF FF FF FF FF FF FF FF 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player2
	.he 00 00 00 00 00 00 00 00 00 00 00 FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF 00 00 00 00 00 FB FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player3
	.he 00 00 00 00 00 00 00 00 00 00 00 FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF 00 00 00 00 00 00 00 00 00 02 05 0A 15
	.he 0A 14 28 54 28 50 20 40 A0 40 80 40 80 00 04 00
	.he 00 00 00 00 00 00 00 00 FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF 00 00 00 00 00 FF FF FF FF FF FF FF FF
	.he 00 FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
.ENDM

USESPRITES = 1

.MACRO	DLINEW
	mva <:1 NMI.dliv
	ift [>?old_dli]<>[>:1]
	mva >:1 NMI.dliv+1
	eif

	ift :2
	lda regA
	eif

	ift :3
	ldx regX
	eif

	ift :4
	ldy regY
	eif

	rti

	.def ?old_dli = *
.ENDM

 icl "rmt/rmtinclude.asm"						;//------------------------------------- ADD THIS LINE FOR RMT REPLAY