/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

	icl "Odium.h"

	org $f0

fcnt	.ds 2
fadr	.ds 2
fhlp	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1

WIDTH	= 48
HEIGHT	= 30

; ---	BASIC switch OFF
	org $2000\ mva #$ff portb\ rts\ ini $2000

; ---	MAIN PROGRAM
	org $2000
ant	dta $44,a(scr)
	dta $04,$04,$04,$84,$04,$04,$04,$84,$04,$84,$84,$04,$84,$04,$84,$84
	dta $04,$04,$84,$04,$84,$84,$04,$84,$84,$84,$84,$04,$04
	dta $41,a(ant)

scr	ins "Odium.scr"

	.ds 0*40

	.ALIGN $0400
fnt	ins "Odium.fnt"

	ift USESPRITES
	.ALIGN $0800
pmg	.ds $0300
	ift FADECHR = 0
	SPRITES
	els
	.ds $500
	eif
	eif

main
; ---	init PMG

	ift USESPRITES
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	eif

	lda:cmp:req $14		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #$00 nmien		;stop NMI interrupts
	sta dmactl
	mva #$fe portb		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	mva #$c0 nmien		;switch on NMI+DLI again

	ift CHANGES		;if label CHANGES defined

_lp	lda trig0		; FIRE #0
	beq stop

	lda trig1		; FIRE #1
	beq stop

	lda consol		; START
	and #1
	beq stop

	lda skctl
	and #$04
	bne _lp			;wait to press any key; here you can put any own routine

	els

null	jmp DLI.dli1		;CPU is busy here, so no more routines allowed

	eif


stop
	mva #$00 pmcntl		;PMG disabled
	tax
	sta:rne hposp0,x+

	mva #$ff portb		;ROM switch on
	mva #$40 nmien		;only NMI interrupts, DLI disabled
	cli			;IRQ enabled

	rts			;return to ... DOS

; ---	DLI PROGRAM

.local	DLI

	?old_dli = *

	ift !CHANGES

dli1	lda trig0		; FIRE #0
	beq stop

	lda trig1		; FIRE #1
	beq stop

	lda consol		; START
	and #1
	beq stop

	lda skctl
	and #$04
	beq stop

	lda vcount
	cmp #$02
	bne dli1

	:3 sta wsync

	DLINEW DLI.dli2
	eif


dli_start

dli2
	sta regA
	lda >fnt+$400*$01
	sta wsync		;line=40
	sta chbase
	DLINEW dli3 1 0 0

dli3
	sta regA
	lda >fnt+$400*$02
	sta wsync		;line=72
	sta chbase
	DLINEW dli9 1 0 0

dli9
	sta regA
	stx regX
	sty regY

s3	lda #$F4
	sta wsync		;line=88
	sta sizem
	sta wsync		;line=89
	sta wsync		;line=90
s4	lda #$00
x8	ldx #$73
c7	ldy #$2C
	sta wsync		;line=91
	sta sizep0
	stx hposp0
	sty colpm0
	DLINEW dli4 1 1 1

dli4
	sta regA
	stx regX
	sty regY
	lda >fnt+$400*$03
	sta wsync		;line=96
	sta chbase
	sta wsync		;line=97
	sta wsync		;line=98
	sta wsync		;line=99
	sta wsync		;line=100
	sta wsync		;line=101
s5	lda #$01
x9	ldx #$80
c8	ldy #$38
	sta wsync		;line=102
	sta sizep0
	stx hposp0
	sty colpm0
	sta wsync		;line=103
	sta wsync		;line=104
	sta wsync		;line=105
	sta wsync		;line=106
	sta wsync		;line=107
	sta wsync		;line=108
s6	lda #$03
x10	ldx #$B4
c9	ldy #$9A
	sta wsync		;line=109
	sta sizep0
	stx hposp0
	sty colpm0
	DLINEW dli10 1 1 1

dli10
	sta regA
	stx regX

	sta wsync		;line=112
	sta wsync		;line=113
	sta wsync		;line=114
x11	lda #$80
c10	ldx #$2E
	sta wsync		;line=115
	sta hposp1
	stx colpm1
	DLINEW dli5 1 1 0

dli5
	sta regA
	lda >fnt+$400*$04
	sta wsync		;line=128
	sta chbase
	DLINEW dli11 1 0 0

dli11
	sta regA
	stx regX

	sta wsync		;line=136
	sta wsync		;line=137
	sta wsync		;line=138
c11	lda #$2C
	sta wsync		;line=139
	sta colpm1
x12	lda #$84
	sta wsync		;line=140
	sta hposp1
c12	lda #$8A
	sta wsync		;line=141
	sta color3
c13	lda #$E8
	sta wsync		;line=142
	sta color3
	sta wsync		;line=143
	sta wsync		;line=144
x13	lda #$83
	sta wsync		;line=145
	sta hposp1
x14	lda #$84
c14	ldx #$2E
	sta wsync		;line=146
	sta hposp1
	stx colpm1
	DLINEW dli12 1 1 0

dli12
	sta regA
	stx regX
	sty regY

	sta wsync		;line=160
	sta wsync		;line=161
	sta wsync		;line=162
	sta wsync		;line=163
	sta wsync		;line=164
	sta wsync		;line=165
	sta wsync		;line=166
x15	lda #$69
x16	ldx #$53
c15	ldy #$2C
	sta wsync		;line=167
	sta hposp1
	stx hposp3
	sty colpm1
	DLINEW dli13 1 1 1

dli13
	sta regA
	stx regX
	sty regY

	sta wsync		;line=176
	sta wsync		;line=177
s7	lda #$01
x17	ldx #$67
c16	ldy #$48
	sta wsync		;line=178
	sta sizep0
	stx hposp0
	sty colpm0
	DLINEW dli14 1 1 1

dli14
	sta regA
	stx regX
	sty regY

	sta wsync		;line=184
	sta wsync		;line=185
	sta wsync		;line=186
	sta wsync		;line=187
	sta wsync		;line=188
s8	lda #$00
x18	ldx #$69
c17	ldy #$4A
	sta wsync		;line=189
	sta sizep0
	stx hposp0
	sty colpm0
	sta wsync		;line=190
s9	lda #$03
x19	ldx #$5D
c18	ldy #$2E
	sta wsync		;line=191
	sta sizep1
	stx hposp1
	sty colpm1
	lda >fnt+$400*$05
x20	ldx #$71
c19	ldy #$2C
	sta wsync		;line=192
	sta chbase
	stx hposp0
	sty colpm0
	DLINEW dli15 1 1 1

dli15
	sta regA

	sta wsync		;line=200
	sta wsync		;line=201
	sta wsync		;line=202
x21	lda #$8C
	sta wsync		;line=203
	sta hposp3
s10	lda #$01
	sta wsync		;line=204
	sta sizep3
	DLINEW dli16 1 0 0

dli16
	sta regA
	stx regX
	sty regY

	sta wsync		;line=208
	sta wsync		;line=209
	sta wsync		;line=210
s11	lda #$00
x22	ldx #$2F
c20	ldy #$3A
	sta wsync		;line=211
	sta sizep3
	stx hposp3
	sty colpm3
s12	lda #$00
x23	ldx #$78
c21	ldy #$24
	sta wsync		;line=212
	sta sizep2
	stx hposp2
	sty colpm2
	DLINEW dli17 1 1 1

dli17
	sta regA
	stx regX
	sty regY

x24	lda #$77
c22	ldx #$28
	sta wsync		;line=216
	sta hposp2
	stx colpm2
	sta wsync		;line=217
x25	lda #$8A
	sta wsync		;line=218
	sta hposp0
c23	lda #$2C
	sta wsync		;line=219
	sta colpm1
s13	lda #$01
	sta wsync		;line=220
	sta sizep0
c24	lda #$FC
	sta wsync		;line=221
	sta colpm0
c25	lda #$E6
c26	ldx #$F8
c27	ldy #$DA
	sta wsync		;line=222
	sta color0
	stx color1
	sty color2
	DLINEW dli6 1 1 1

dli6
	sta regA
	lda >fnt+$400*$06
	sta wsync		;line=224
	sta chbase

	lda regA
	rti

.endl

; ---

CHANGES = 1
FADECHR	= 0

SCHR	= 127

; ---

.proc	NMI

	bit nmist
	bpl VBL

	jmp DLI.dli_start
dliv	equ *-2

VBL
	sta regA
	stx regX
	sty regY

	sta nmist		;reset NMI flag

	mwa #ant dlptr		;ANTIC address program

	mva #@dmactl(wide|dma|lineX1|players|missiles) dmactl	;set new screen width

	inc cloc		;little timer

; Initial values

	lda >fnt+$400*$00
	sta chbase
c0	lda #$0C
	sta colbak
c1	lda #$14
	sta color0
c2	lda #$16
	sta color1
c3	lda #$1A
	sta color2
c4	lda #$E8
	sta color3
	lda #$02
	sta chrctl
	lda #$04
	sta gtictl
s0	lda #$03
	sta sizep0
	sta sizep2
	sta sizep3
s1	lda #$F0
	sta sizem
x0	lda #$6D
	sta hposp0
x1	lda #$8C
	sta hposp2
x2	lda #$52
	sta hposp3
x3	lda #$AC
	sta hposm2
x4	lda #$4B
	sta hposm3
c5	lda #$9A
	sta colpm0
	sta colpm2
	sta colpm3
s2	lda #$01
	sta sizep1
x5	lda #$7E
	sta hposp1
c6	lda #$2C
	sta colpm1
x6	lda #$8E
	sta hposm1
x7	lda #$00
	sta hposm0

	mwa #DLI.dli_start dliv	;set the first address of DLI interrupt

;this area is for yours routines

quit
	lda regA
	ldx regX
	ldy regY
	rti

.endp

; ---
	run main
; ---

	opt l-

.MACRO	SPRITES
missiles
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 40 40 00 00 20 00 00
	.he 00 00 00 00 00 00 00 00 00 40 00 60 00 60 80 C0
	.he 80 40 00 40 40 40 40 60 00 20 40 40 40 40 00 40
	.he 00 40 40 40 00 40 C0 C0 C0 40 00 C0 40 C0 40 F0
	.he 00 E0 40 40 00 80 80 80 00 00 20 00 20 00 30 30
	.he 00 10 00 10 00 20 00 70 80 30 00 70 00 30 48 38
	.he 08 08 48 58 58 20 50 20 50 20 70 00 70 20 70 30
	.he 70 30 70 30 F0 30 F0 70 F0 30 F0 30 70 30 70 30
	.he 30 20 30 30 30 30 30 30 30 30 70 30 70 30 70 30
	.he 30 30 30 30 30 30 30 30 30 30 30 30 30 30 30 30
	.he 10 30 50 30 F0 60 F0 00 70 00 70 00 30 00 20 00
	.he 20 00 00 00 40 00 40 00 40 80 00 00 00 00 00 00
	.he 00 00 40 00 40 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player0
	.he 00 00 00 00 00 00 00 00 00 F0 C0 FC E0 FF F4 FF
	.he F2 FF E1 FF C1 FF E3 FF F7 FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF 87 FF 01 FF C7 FF EF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FC FC
	.he F8 F8 F8 FF FF 7F FF FF FF 7F FF FF 78 7E 7F 7F
	.he FF FF FF E2 40 00 C0 00 C0 00 C0 00 C0 00 E0 00
	.he F0 80 F8 80 F0 C0 E0 80 C0 80 80 80 E0 80 20 80
	.he F0 00 F0 00 F0 C0 F0 C0 F8 E0 F8 E0 F8 F0 FC F0
	.he FC F8 FE F8 FE FC FE FC FF F0 FF C0 FE 80 FF 84
	.he FF 0E FF 00 DF 00 8E 00 86 00 70 7C 7C 7E 7E 7E
	.he 7E 6E 06 06 80 00 08 01 FA FD 7E 7D 7E 7F 7F 7F
	.he 7F 7F 7F 7F CF 8F 1F 1F 3F 3F 7F 60 E0 C0 C0 C0
	.he 00 00 00 00 00 88 3C EE C8 E6 F4 F8 7C 06 B0 ED
	.he FF 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player1
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 08 1E 1E
	.he 32 3A 3E 7F 7F F5 FF FF FF FF F9 FE FF FE FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FB
	.he F3 FB FF FF FF FF FF FF FF EF E7 F7 F7 F7 E7 F7
	.he F7 FF FF FF FE FE FE FE FE FF FF FF FF FE FE FE
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 1F
	.he 1F 3F 3B 3F 7F 7F 7F 7F 7F 7F FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF 7F 7F FF 7F FF 7F FF FF FF
	.he FF FF FF FF FF FB FF FF F7 F7 0F 0C 28 68 68 28
	.he 62 62 61 61 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player2
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 0E C0
	.he 07 E0 82 F0 80 F8 C0 BC C0 FF C0 FF C0 FF E0 FF
	.he F8 FC F0 FF F8 FF FC FF FC FF FE FF FF FF FC FF
	.he FC FE F8 FC F8 FF FC FF FE FF FE FF FC FF F0 FE
	.he E0 FC C0 FC F8 B8 C0 F8 80 FE FC FB FE FF FC FF
	.he FC FF FC FF FC FE FC FF FF FE FF FE FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF FF FF FE FF
	.he CE FF 84 FF C0 FF F6 FF FE FF FF FF FF FF FF FF
	.he FF FF FF FF FF FF FF FF FF FF FF FF BF BF BF BF
	.he BF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF
	.he 7F FF FF FF FF FF 9F FF 0F 9F 03 FF 91 FF FC FF
	.he FE FF FC FB FF FF FF FF FF BF FF BE FF 9C FF 98
	.he FF 80 FF 80 FF 80 FE C0 FC E0 F8 F0 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 FF FF FF FF
	.he 00 FF FF FF FF F7 FF FF FF 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
player3
	.he 00 00 00 00 00 00 00 00 01 07 01 0F 03 0F 03 0F
	.he 01 07 01 07 03 0F 03 7F 07 FF 07 FF 0F FF 1F FF
	.he 3F FF BF FF 2F FF 4F FF 1F FF 1F FF 2F FF 0F FF
	.he 1F FF 0F FF 07 3F 19 AF A1 3F 43 FF 03 FF 07 FF
	.he 2F FF 1F FF 3F FF 3F FF 7F FF FF FF FF FF FF FF
	.he FF FF FF FF 3F FF 3F FF 3F FF 1F FF 3F FF 1F FF
	.he 3F FF 3F FF 7F FF FF FF BF FF FF FF FF FF FF FF
	.he FF FF FF 1F FF 0F FF 1F FF 7F FF 5F FF 3F FF FF
	.he FF FF FF 7F FF FF FF FF FF FF FF FF FF 3F FF 1F
	.he FF 07 3F 0F 7F 1F 7F 3F FF 7F FF FF FF 7F FF 1F
	.he FF 07 3F 03 1F 00 03 00 07 01 1F 07 3F 1F FF 3F
	.he FF 7F FF FF FF FF FF FF FF FF FF 7F FF 3F 7F 0F
	.he 3F 1F 7F 3F FF FF F3 3F FF 1F 1F 5F 1F 1F 7F BF
	.he 3F 3F 7F 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
	.he 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
.ENDM

USESPRITES = 1

.MACRO	DLINEW
	mva <:1 NMI.dliv
	ift [>?old_dli]<>[>:1]
	mva >:1 NMI.dliv+1
	eif

	ift :2
	lda regA
	eif

	ift :3
	ldx regX
	eif

	ift :4
	ldy regY
	eif

	rti

	.def ?old_dli = *
.ENDM

